/**
 * License Agreement.
 *
 *  JBoss RichFaces 3.0 - Ajax4jsf Component Library
 *
 * Copyright (C) 2007  Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package org.richfaces.model;


/**
 * @author asmirnov@exadel.com (latest modification by $Author: ishabalov $)
 * @version $Revision: 1.3 $ $Date: 2007/02/21 20:35:05 $
 */
public interface TabModel {

    /**
     * Get Get internal value for this tab - to store in selectedTab attribute of {@link org.richfaces.component.UITabPanel}.
     * by default, if no tabValue set, as it's value used ordered number of this tab in panel.
     *
     * @return Returns the value.
     */
    public Object getName();

    /**
     * Set Get internal value for this tab - to store in selectedTab attribute of {@link org.richfaces.component.UITabPanel}.
     *
     * @param newvalue
     */
    public void setName(Object newvalue);

    public boolean isDisabled();

    public void setDisabled(boolean disabled);

    /**
     * Get label for this tab.
     *
     * @return Returns the label.
     */
    public String getLabel();

    /**
     * Set label for this tab.
     *
     * @param newvalue
     */
    public void setLabel(String newvalue);

    /**
     * Get width of label for this tab.
     *
     * @return Returns the labelWidth.
     */
    public String getLabelWidth();

    /**
     * Set width of label for this tab.
     *
     * @param newvalue
     */
    public void setLabelWidth(String newvalue);

    /**
     * Get Tab title - for pop-up message.
     *
     * @return Returns the title.
     */
    public String getTitle();

    /**
     * Set Tab title - for pop-up message.
     *
     * @param newvalue
     */
    public void setTitle(String newvalue);

    /**
     * Get Tab selection behavior for panel - one of "client", "server", "ajax", "page".
     *
     * @return Returns the switchType.
     */
    public String getSwitchType();

    /**
     * Set Tab selection behavior for panel - one of "client", "server", "ajax", "page".
     * @param newvalue
     */
    public void setSwitchType(String newvalue);
}