/**
 * License Agreement.
 *
 *  JBoss RichFaces 3.0 - Ajax4jsf Component Library
 *
 * Copyright (C) 2007  Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package org.richfaces.renderkit;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.richfaces.org.apache.commons.lang.StringEscapeUtils;

/**
 * @author Nick Belaevski - nbelaevski@exadel.com
 * created 11.12.2006
 * 
 */
public class TemplateUtil {
	
	private final static Pattern PARAMETER_REPLACER_PATTERN = Pattern.compile("(\\\\)?\\{([^\\}]+)\\}");
	
	public static String replaceParams(String string, String paramsVarName) {
		Matcher m = PARAMETER_REPLACER_PATTERN.matcher(string);
		StringBuffer sb = new StringBuffer("\"");
		
		int lastPosition = 0;
		
		while (m.find()) {
			String firstGroup = m.group(1);
			if (firstGroup == null || firstGroup.length() == 0) {
				sb.append(StringEscapeUtils.escapeJavaScript(string.substring(lastPosition, m.start(2) - 1)));
				
				String paramAccess = paramsVarName + "['" + m.group(2) + "']";
				
				sb.append("\" + ((!!" + paramAccess + ") ? " + paramAccess + " : \"\") + \"");
			} else {
				StringBuffer sbUnEsc = new StringBuffer();
				sbUnEsc.append(string.substring(lastPosition, m.end(1) - 1));
				sbUnEsc.append("{");
				sbUnEsc.append(m.group(2));
				sbUnEsc.append("}");

				sb.append(StringEscapeUtils.escapeJavaScript(sbUnEsc.toString()));
			}

			lastPosition = m.end(2) + 1;
		}
		if (lastPosition < string.length()) {
			sb.append(StringEscapeUtils.escapeJavaScript(string.substring(lastPosition)));
		}
		sb.append("\"");
		return sb.toString();
	}

	public static void main(String[] args) {
		System.out.println(TemplateUtil.replaceParams("test string \" \n with \\{pa\\rams} {name} \"and {value}1", "params"));
	}
}
