/**
 * License Agreement.
 *
 * Ajax4jsf 1.1 - Natural Ajax for Java Server Faces (JSF)
 *
 * Copyright (C) 2007 Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package org.richfaces.renderkit.html;


// 
// Imports
//
import java.util.Iterator;
import java.util.Collection;
import java.io.IOException;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import org.ajax4jsf.framework.renderer.ComponentsVariableResolver;
import org.ajax4jsf.framework.renderer.ComponentVariables;
import org.ajax4jsf.framework.resource.InternetResource;
import org.ajax4jsf.framework.resource.InternetResource;
//
//
//


import org.richfaces.renderkit.html.SimpleTogglePanelRenderer;



/**
 * Renderer for component class org.richfaces.renderkit.html.SimpleToggleControlTemplate
 */
public class SimpleToggleControlTemplate extends SimpleTogglePanelRenderer {

	public SimpleToggleControlTemplate () {
		super();
	}

	// 
	// Declarations
	//
	private final InternetResource[] styles = {
						getResource("css/simpleTogglePanel.xcss")
	};

private InternetResource[] stylesAll = null;

protected InternetResource[] getStyles() {
	synchronized (this) {
		if (stylesAll == null) {
			InternetResource[] rsrcs = super.getStyles();
			boolean ignoreSuper = rsrcs == null || rsrcs.length == 0;
			boolean ignoreThis = styles == null || styles.length == 0;
			
			if (ignoreSuper) {
				if (ignoreThis) {
					stylesAll = new InternetResource[0];	
				} else {
					stylesAll = styles;
				}
			} else {
				if (ignoreThis) {
					stylesAll = rsrcs;
				} else {
					java.util.Set rsrcsSet = new java.util.LinkedHashSet();

					for (int i = 0; i < rsrcs.length; i++ ) {
						rsrcsSet.add(rsrcs[i]);
					}

					for (int i = 0; i < styles.length; i++ ) {
						rsrcsSet.add(styles[i]);
					}

					stylesAll = (InternetResource[]) rsrcsSet.toArray(new InternetResource[rsrcsSet.size()]);
				}
			}
		}
	}
	
	return stylesAll;
}
	private final InternetResource[] scripts = {
						new org.ajax4jsf.framework.resource.PrototypeScript()
						,
				new org.ajax4jsf.framework.ajax.AjaxScript()
						,
				new org.ajax4jsf.framework.ajax.ImageCacheScript()
						,
				getResource("/org/ajax4jsf/renderkit/html/scripts/form.js")
						,
				getResource("/org/richfaces/renderkit/html/scripts/browser_info.js")
						,
				getResource("scripts/simpleTogglePanel.js")
	};

private InternetResource[] scriptsAll = null;

protected InternetResource[] getScripts() {
	synchronized (this) {
		if (scriptsAll == null) {
			InternetResource[] rsrcs = super.getScripts();
			boolean ignoreSuper = rsrcs == null || rsrcs.length == 0;
			boolean ignoreThis = scripts == null || scripts.length == 0;
			
			if (ignoreSuper) {
				if (ignoreThis) {
					scriptsAll = new InternetResource[0];	
				} else {
					scriptsAll = scripts;
				}
			} else {
				if (ignoreThis) {
					scriptsAll = rsrcs;
				} else {
					java.util.Set rsrcsSet = new java.util.LinkedHashSet();

					for (int i = 0; i < rsrcs.length; i++ ) {
						rsrcsSet.add(rsrcs[i]);
					}

					for (int i = 0; i < scripts.length; i++ ) {
						rsrcsSet.add(scripts[i]);
					}

					scriptsAll = (InternetResource[]) rsrcsSet.toArray(new InternetResource[rsrcsSet.size()]);
				}
			}
		}
	}
	
	return scriptsAll;
}
	// 
	// 
	//


	private String convertToString(Object obj ) {
		return ( obj == null ? "" : obj.toString() );
	}
	private String convertToString(boolean b ) {
		return String.valueOf(b);
	}
	private String convertToString(int b ) {
		return b!=Integer.MIN_VALUE?String.valueOf(b):"";
	}
	private String convertToString(long b ) {
		return b!=Long.MIN_VALUE?String.valueOf(b):"";
	}
	
	/**
	 * Get base component class, targetted for this renderer. Used for check arguments in decode/encode.
	 * @return
	 */
	protected Class getComponentClass() {
		return org.richfaces.component.UISimpleTogglePanel.class;
	}

	
	public void doEncodeBegin(ResponseWriter writer, FacesContext context, UIComponent component ) throws IOException {
		ComponentVariables variables = ComponentsVariableResolver.getVariables(this, component);
		doEncodeBegin(writer, context, (org.richfaces.component.UISimpleTogglePanel)component, variables );
	}		

	public void doEncodeBegin(ResponseWriter writer, FacesContext context, org.richfaces.component.UISimpleTogglePanel component, ComponentVariables variables ) throws IOException {
	    java.lang.String clientId = component.getClientId(context);
writer.startElement("div", component);
			getUtils().writeAttribute(writer, "class", "dr-stglpnl rich-stglpanel " + convertToString(component.getAttributes().get("styleClass")) );
						getUtils().writeAttribute(writer, "id", clientId );
						getUtils().writeAttribute(writer, "style", "width: " + convertToString(component.getAttributes().get("width")) + "; " + convertToString(component.getAttributes().get("style")) + ";" );
			//
// pass thru attributes
//
getUtils().encodeAttributesFromArray(context,component,new String[] {
    "class" ,
	    "dir" ,
	    "lang" ,
	    "onclick" ,
	    "ondblclick" ,
	    "onkeydown" ,
	    "onkeypress" ,
	    "onkeyup" ,
	    "onmousedown" ,
	    "onmousemove" ,
	    "onmouseout" ,
	    "onmouseover" ,
	    "onmouseup" ,
	    "style" ,
	    "title" ,
	    "xml:lang" });
//
//
//

writer.startElement("script", component);
			getUtils().writeAttribute(writer, "type", "text/javascript" );
			
writer.writeText(convertToString("SimpleTogglePanelManager.add(new SimpleTogglePanel(\"" + convertToString(clientId) + "\", \"" + convertToString(component.getAttributes().get("opened")) + "\""),null);


                if(component.getFacet("openMarker")!=null && component.getFacet("openMarker").isRendered()) {
                
writer.writeText(convertToString(", \""),null);

UIComponent indexChildren_2 = component.getFacet("openMarker");
if (null != indexChildren_2 && indexChildren_2 .isRendered()) {
	renderChild(context, indexChildren_2);
}

writer.writeText(convertToString("\""),null);


                } else {
                
writer.writeText(convertToString(", null"),null);


                }
                

                if(component.getFacet("closeMarker")!=null && component.getFacet("closeMarker").isRendered()) {
                
writer.writeText(convertToString(", \""),null);

UIComponent indexChildren_3 = component.getFacet("closeMarker");
if (null != indexChildren_3 && indexChildren_3 .isRendered()) {
	renderChild(context, indexChildren_3);
}

writer.writeText(convertToString("\""),null);


                } else {
                
writer.writeText(convertToString(", null"),null);


                }
                
writer.writeText(convertToString("));"),null);

writer.endElement("script");
getUtils().encodeBeginFormIfNessesary(context, component);

writer.startElement("div", component);
			getUtils().writeAttribute(writer, "class", "dr-stglpnl-h rich-stglpanel-header " + convertToString(component.getAttributes().get("headerClass")) );
						getUtils().writeAttribute(writer, "id", convertToString(clientId) + "_header" );
						getUtils().writeAttribute(writer, "onclick", getOnClick(context,component) );
						getUtils().writeAttribute(writer, "style", "position : relative;" );
			
writer.writeText(convertToString(component.getAttributes().get("label")),null);

writer.write("&nbsp;");
writer.startElement("div", component);
			getUtils().writeAttribute(writer, "id", convertToString(clientId) + "_switch" );
						getUtils().writeAttribute(writer, "style", "position : absolute; top: 0px; right: 5px;" );
			

                if(component.isOpened()){
                    if(component.getFacet("closeMarker")!=null && component.getFacet("closeMarker").isRendered()) {
                
UIComponent indexChildren_4 = component.getFacet("closeMarker");
if (null != indexChildren_4 && indexChildren_4 .isRendered()) {
	renderChild(context, indexChildren_4);
}


                    } else {
                   	  writer.write("&#171;");                      	                                           
                    }
                } else {
                    if(component.getFacet("openMarker")!=null && component.getFacet("openMarker").isRendered()) {
                
UIComponent indexChildren_5 = component.getFacet("openMarker");
if (null != indexChildren_5 && indexChildren_5 .isRendered()) {
	renderChild(context, indexChildren_5);
}


                    } else {
                   	   writer.write("&#187;");                
                    }
                }
                
writer.endElement("div");
writer.endElement("div");

            if((component.getSwitchType()!=null) && (component.getSwitchType().equals(component.CLIENT_SWITCH_TYPE)==true)){
        
writer.startElement("div", component);
			getUtils().writeAttribute(writer, "style", "display: none;" );
			
writer.startElement("input", component);
			getUtils().writeAttribute(writer, "id", convertToString(clientId) + "_input" );
						getUtils().writeAttribute(writer, "name", clientId );
						getUtils().writeAttribute(writer, "type", "hidden" );
						getUtils().writeAttribute(writer, "value", component.getAttributes().get("opened") );
			
writer.endElement("input");
writer.endElement("div");

            }
        
getUtils().encodeEndFormIfNessesary(context, component);

writer.startElement("div", component);
			getUtils().writeAttribute(writer, "id", convertToString(clientId) + "_body" );
						getUtils().writeAttribute(writer, "style", "display : " + convertToString(getdivdisplay(context,component)) + ";              overflow: auto; height: " + convertToString(component.getAttributes().get("height")) + "; width: 100%;" );
			
writer.startElement("table", component);
			getUtils().writeAttribute(writer, "cellpadding", "0" );
						getUtils().writeAttribute(writer, "style", "width: 100%" );
			
writer.startElement("tr", component);

writer.startElement("td", component);
			getUtils().writeAttribute(writer, "class", "dr-stglpnl-b rich-stglpanel-body " + convertToString(component.getAttributes().get("bodyClass")) );
			

	}		
	
    public void doEncodeChildren(ResponseWriter writer, FacesContext context, UIComponent component) throws IOException {
		ComponentVariables variables = ComponentsVariableResolver.getVariables(this, component);
		doEncodeChildren(writer, context, (org.richfaces.component.UISimpleTogglePanel)component, variables );
	}		

    public void doEncodeChildren(ResponseWriter writer, FacesContext context, org.richfaces.component.UISimpleTogglePanel component, ComponentVariables variables) throws IOException {
	    
renderChildren(context, component);


	}		

	/* (non-Javadoc)
	 * @see javax.faces.render.Renderer#getRendersChildren()
	 */
	public boolean getRendersChildren() {
		return true;
	}

	public void doEncodeEnd(ResponseWriter writer, FacesContext context, org.richfaces.component.UISimpleTogglePanel component, ComponentVariables variables) throws IOException {
	  
writer.endElement("td");
writer.endElement("tr");
writer.endElement("table");
writer.endElement("div");
writer.endElement("div");

	}		
	
	public void doEncodeEnd(ResponseWriter writer, FacesContext context, UIComponent component) throws IOException {
		ComponentVariables variables = ComponentsVariableResolver.getVariables(this, component);
		doEncodeEnd(writer, context, (org.richfaces.component.UISimpleTogglePanel)component, variables );

		ComponentsVariableResolver.removeVariables(this, component);
	}		
	

}
