/**
 * License Agreement.
 *
 *  JBoss RichFaces 3.0 - Ajax4jsf Component Library
 *
 * Copyright (C) 2007  Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package org.richfaces.renderkit.html.images;

import java.io.Serializable;
import java.util.Date;

import javax.faces.context.FacesContext;

import org.ajax4jsf.framework.resource.GifRenderer;
import org.ajax4jsf.framework.resource.InternetResourceBuilder;
import org.ajax4jsf.framework.resource.Java2Dresource;
import org.ajax4jsf.framework.skin.Skin;
import org.ajax4jsf.framework.skin.SkinFactory;
import org.ajax4jsf.framework.util.HtmlColor;

public abstract class TreeImageBase extends Java2Dresource {

	public TreeImageBase() {
		setRenderer(new GifRenderer());
		setLastModified(new Date(InternetResourceBuilder.getInstance().getStartTime()));
	}

	protected Object getDataToStore(FacesContext context, Object data) {
		
		TreeImageData dt = new TreeImageData();
		String tmp;
		int intValue;
		Skin skin = SkinFactory.getInstance().getSkin(context);
		tmp = (String) skin.getParameter(context,"generalTextColor");
		if (tmp != null) {
			intValue = HtmlColor.decode(tmp).getRGB();
			dt.setGeneralColor(new Integer(intValue));
		} else dt.setGeneralColor(null);

		tmp = (String) skin.getParameter(context,"controlBackgroundColor");
		if (tmp != null) {
			intValue = HtmlColor.decode(tmp).getRGB();
			dt.setControlColor(new Integer(intValue));
		} else dt.setControlColor(null);

		tmp = (String) skin.getParameter(context,"trimColor");
		if (tmp != null) {
			intValue = HtmlColor.decode(tmp).getRGB();
			dt.setTrimColor(new Integer(intValue));
		} else dt.setTrimColor(null);
		
		return dt;
	}
	
	public boolean isCacheable() {
		return true;
	}

	protected static class TreeImageData implements Serializable{
		private static final long serialVersionUID = 1732700513743861251L;
		
		private Integer controlColor;
		private Integer trimColor;
		private Integer generalColor;
		
		public Integer getControlColor() {
			return controlColor;
		}
		public void setControlColor(Integer controlColor) {
			this.controlColor = controlColor;
		}
		public Integer getTrimColor() {
			return trimColor;
		}
		public void setTrimColor(Integer trimColor) {
			this.trimColor = trimColor;
		}
		public Integer getGeneralColor() {
			return generalColor;
		}
		public void setGeneralColor(Integer generalColor) {
			this.generalColor = generalColor;
		}
	
	}
	
}
